-- requires loaded scene planetExample.i3d

-- root/scenegraph
--   sun
--     planetRot
--       planet

if g_updateListener then
    removeUpdateListener(g_updateListener)
end

local sun = getChildAt(getChildAt(getRootNode(), 0), 0)

function updateFunction(dt)
    local numChildren = getNumOfChildren(sun)
    for i = 0, numChildren - 1 do
        local planetRot = getChildAt(sun, i)
        local planet = getChildAt(planetRot, 0)
        local x_distance, _, _ = getTranslation(planet)
        -- rotate planet around sun
        rotateAboutLocalAxis(planetRot, 0.05 * (1 / x_distance), 0.3, 1, 0.1)
        -- rotate planet itself
        rotateAboutLocalAxis(planet, 0.008 * x_distance, 0.1, 1, 0.1)
    end
end

g_updateListener = addUpdateListener("updateFunction")